#!/usr/bin/python
# -*- coding: utf-8 -*-
import gtk
import hildon
import hildondesktop
import os
from subprocess import *

class UssdConfigDialog(gtk.Dialog):
    def __init__(self, queryNumber):
        gtk.Dialog.__init__(self, "USSD widget", None,
                            gtk.DIALOG_DESTROY_WITH_PARENT | gtk.DIALOG_NO_SEPARATOR,
                            ("Save", gtk.RESPONSE_OK))
        self.ussdNumber = hildon.Entry(gtk.HILDON_SIZE_AUTO)
        self.ussdNumber.set_text(queryNumber)
        self.vbox.add(gtk.Label("USSD number"))
        self.vbox.add(self.ussdNumber)
        self.show_all()
        self.parent

def get_ussd_number():
    try :
        config = open(os.getenv("HOME")+"/.ussdWidget.conf","r")
        config.readline()
        config.readline()
        number = config.readline().strip()
        config.close()
        return number
    except  IOError:
        return None

def ussd_renew(button):
    query = get_ussd_number()
    if query :
        p = Popen(['python', '/usr/bin/ussdquery.py', query], stdout=PIPE)
        reply = p.communicate()[0].strip()
        if reply == "" :
            reply = "   Error   "
    else :
        reply = " Bad config "
    button.set_label(reply)

def on_show_settings(widget):
    queryNumber = get_ussd_number()
    if queryNumber == None :
        queryNumber = ""

    dialog = UssdConfigDialog(queryNumber)
    dialog.run()

    config = open(os.getenv("HOME")+"/.ussdWidget.conf","w")
    config.writelines(["# Parameters are taken by line number, do not move them\n", "# USSD query to be run by widget\n", dialog.ussdNumber.get_text(), "\n"])
    config.close()

    dialog.destroy()
    
    if queryNumber == "" :
        widget.button.set_label("Click to update")

class UssdWidgetPlugin(hildondesktop.HomePluginItem):
    def __init__(self):
        hildondesktop.HomePluginItem.__init__(self)
        query = get_ussd_number()
        if query :
            self.button = gtk.Button("Click to update")
        else :
            self.button = gtk.Button("Configure me")
        self.button.connect("clicked", ussd_renew)
        self.button.show_all()
        self.add(self.button)

        self.set_settings(True)
        self.connect("show-settings", on_show_settings)    

hd_plugin_type = UssdWidgetPlugin

# The code below is just for testing purposes.
# It allows to run the widget as a standalone process.
if __name__ == "__main__":
    import gobject
    gobject.type_register(hd_plugin_type)

